//animation demo - sheep game

float DIST = 50f;
long TIME_INC = 133L;
int NUM_SHEEP = 1000;
int SHEEP_SIZE = 3;

boolean keysPressed[] = new boolean[4];
Player p1;
Player[] sheep = new Player[NUM_SHEEP];
long timeToMove = 0;

void setup()
{
  size(600, 400);
  frame.setResizable(true);
  noStroke(); 
  frameRate(60);
  
  p1 = new Player(50, height/2 - 10, 20, 20);
  
  for (int i = 0; i < sheep.length; i++)
  {
    sheep[i] = new Player(
      random(DIST * 3, width - (DIST * 3)), 
      random(DIST * 3, height - (DIST * 3)),
      SHEEP_SIZE, SHEEP_SIZE
      );
  }
}

void draw()
{
  background(0);

  p1.update();
  fill(255,0,0);
  p1.draw();

  moveSheep();

  fill(0,128,0);
  rect(width/2 - 25, height/2 - 25, 50, 50);
  println("" + frameRate);
}

void moveSheep()
{
  boolean readyToMove = false;
  for (int i = 0; i < sheep.length; i++)
  {
    if (sheep[i] != null)
    {
      if (randomPlayerMovement(sheep[i], i) == true)
      {
        readyToMove = true;
      }
      
      sheep[i].update();
      fill(0,0,255);
      sheep[i].draw();
  
  
      if (sheep[i].xpos + sheep[i].wpos/2 > width/2 - 25 
          && sheep[i].xpos + sheep[i].wpos/2 < width/2 + 25
          && sheep[i].ypos + sheep[i].hpos/2 > height/2 - 25 
          && sheep[i].ypos + sheep[i].hpos/2 < height/2 + 25
          )
      {
        println("YOU WON!!!");
        //exit();
        sheep[i] = null;
      }
    }
  }
  if (readyToMove == true)
  {
    timeToMove += TIME_INC;
  }
}
  
  
boolean randomPlayerMovement(Player player, int num)
{
  if (millis() > timeToMove)
  {
    if (p1.xpos > player.xpos && player.xpos >= DIST * 3)
    {
      new MovementTimer(player, millis(), millis() + (long)random(500,2000), -DIST/2, 0f);     
    }
    else if (p1.xpos < player.xpos && player.xpos < width - DIST * 3)
    {
      new MovementTimer(player, millis(), millis() + (long)random(500,2000), DIST/2, 0f);     
    }
    
    if (p1.ypos < player.ypos && player.ypos <= height -  DIST * 3)
    {
      new MovementTimer(player, millis(), millis() + (long)random(500,2000), 0f, DIST/2);     
    }
    else if (p1.ypos > player.ypos && player.ypos > DIST * 3)
    {
      new MovementTimer(player, millis(), millis() + (long)random(500,2000), 0f, -DIST/2);     
    } 
  
    return true;
  }
  
  return false;
}

void keyPressed()
{  
  if (key == CODED) 
  {
    if (keyCode == UP && keysPressed[0] == false) 
    {
      keysPressed[0] = true;
      new MovementTimer(p1, millis(), millis() + 1000, 0f, -DIST);
    }
    if (keyCode == DOWN && keysPressed[1] == false) 
    {
      keysPressed[1] = true;
      new MovementTimer(p1, millis(), millis() + 1000, 0f, DIST);
    } 
    if (keyCode == RIGHT && keysPressed[2] == false) 
    {
      keysPressed[2] = true;
      new MovementTimer(p1, millis(), millis() + 1000, DIST, 0f);
    }
    if (keyCode == LEFT && keysPressed[3] == false) 
    {
      keysPressed[3] = true;
      new MovementTimer(p1, millis(), millis() + 1000, -DIST, 0f);
    }
  } 
}

void keyReleased()
{
  keysPressed[0] = false;
  keysPressed[1] = false;  
  keysPressed[2] = false;  
  keysPressed[3] = false;  
}
